package com.fisco.app.client;

import com.fisco.app.common.CommonClient;
import com.fisco.app.contract.BcosCURD;
import com.fisco.app.contract.TestCRUD;
import com.fisco.app.utils.SpringUtils;
import org.fisco.bcos.sdk.BcosSDK;
import org.fisco.bcos.sdk.model.TransactionReceipt;
import org.fisco.bcos.sdk.transaction.model.exception.ContractException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;
import org.springframework.stereotype.Service;

@Service
public class BcosClient extends CommonClient implements ApplicationRunner {
    public static final Logger logger = LoggerFactory.getLogger(BcosClient.class.getName());
    @Override
    public void remove(String name) {

    }

    @Override
    public void run(ApplicationArguments args) throws Exception {
        BcosSDK sdk = SpringUtils.getBean("bcosSDK");
        deploy("BcosCURD", BcosCURD.class, sdk, 1);
    }
    public String set(String a,String b){
        BcosCURD bcosCURD = (BcosCURD) getContractMap().get("BcosCURD");

        TransactionReceipt receipt = bcosCURD.set(a,b);
        logger.info("调用CRUDClient的set方法");
        logger.info("结果：{}", receipt);
        return receipt.getTransactionHash();
    }
    public Boolean query(String txid){
        BcosCURD bcosCURD = (BcosCURD) getContractMap().get("BcosCURD");
        try {
            if ("".equals(bcosCURD.query(txid))){
                return false;
            }
        } catch (ContractException e) {
            e.printStackTrace();
        }
        return true;
    }
}
